package com.pqs9900.serviceImpl.HisData;

import com.pqs9900.mapper.HisData.DataFlucMapper;
import com.pqs9900.pojo.HisData.DataFluc;
import com.pqs9900.service.HisData.DataFlucService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.concurrent.ThreadPoolTaskExecutor;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.Callable;
import java.util.concurrent.Future;

/** @Author denghuajun
 * @Description //TODO 电压波动
 * @Date  2018/12/17 10:51
 **/
@Service
public class DataFlucServiceImpl implements DataFlucService {

    private static final Logger logger= LoggerFactory.getLogger(DataFlucServiceImpl.class);

    @Autowired
    private DataFlucMapper dataFlucMapper;

    @Autowired
    private ThreadPoolTaskExecutor taskExecutor;

    @Override
    public int saveDataFluc(DataFluc dataFluc) {
        return dataFlucMapper.insert(dataFluc);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public int insertDataFluc(List<DataFluc> list) {
        return dataFlucMapper.insertDataFluc(list);
    }

    /**
     * 采用线程池进行数据入库
     * @param listDataFluc 电压波动数据
     */
    @Override
    public Future insertDataFlucExecutor(List<DataFluc> listDataFluc) {
        int inum = 100 ;//每次解析入库条目数
        Callable callable = new Callable() {
            @Override
            public Object call() throws Exception {
                int nCyclicTimes;//循环次数（总长度/批量入库条目数）
                int fromIndex,toIndex;//获取数据的起始和结束下标
                try {
                    nCyclicTimes = (int) Math.ceil(listDataFluc.size() / (double) inum);
                    List<DataFluc> tmpListDataFluc = new ArrayList<>();
                    for (int i = 0; i < nCyclicTimes; i++) {
                        tmpListDataFluc.clear();
                        //假如是最后一次循环则获取循环到结束
                        fromIndex = i * inum;
                        if (i == nCyclicTimes - 1) {
                            toIndex = listDataFluc.size();
                        } else {
                            toIndex = (i + 1) * inum;
                        }
                        //可以先按下标截取，再入库
                        tmpListDataFluc.addAll(listDataFluc.subList(fromIndex, toIndex));
                        // TODO 做批量入库的操作
                        dataFlucMapper.insertDataFluc(tmpListDataFluc);
                    }
                    return "SUCCESS";
                } catch (Exception e) {
                    logger.error("电压波动导入异常，异常是" + e.toString());
                    return "FAIL";
                }
            }
        };
        return taskExecutor.submit(callable);
    }
}
